﻿//////////////////////////////////////////////
// RenderCommandQueue.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class RenderCommand ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../../Dll/DllDefines.h"

#include "RenderCommand.h"

// nkMemory
#include <NilkinsMemory/Containers/BufferCast.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT RenderCommandQueue final
	{
		public :

			// Getters
			const nkMemory::BufferCast<RenderCommand>& getCommands () const ;

			// Manipulations
			void addCommand (const RenderCommand& command) ;

		private :

			// Attributes
			nkMemory::BufferCast<RenderCommand> _commands ;
	} ;
}