﻿//////////////////////////////////////////////
// FileLogger.h
//
//////////////////////////////////////////////

/// Defines, macros --------------------------

#pragma once

/// Includes ---------------------------------

// nkLog
#include "../Dll/DllDefines.h"

#include "Logger.h"

// Standards
#include <fstream>
#include <string>

/// Class ------------------------------------
	
namespace nkLog
{
	class DLL_LOG_EXPORT FileLogger final : public Logger
	{			
		public :
		
			// Constructor, destructor
			FileLogger (StringView filePath) noexcept ;
			virtual ~FileLogger () ;

			// Getters
			StringView getOutputFilePath () const ;

			// Setters
			void setOutputFilePath (StringView path) ;

			// Actions
			virtual void log (StringView message, StringView className) override ;

		private :
		
			// Attributes
			// Output info
			std::string _filePath ;
			std::ofstream _file ;
	} ;
}